package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;

/**
 * Criteria class for the TBNurseryDetails entity. This class is used in TBNurseryDetailsResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-nursery-details?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBNurseryDetailsCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private StringFilter workerName;

    private StringFilter trayNumber;

    private LongFilter tbActivityId;

    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public StringFilter getWorkerName() {
        return workerName;
    }

    public void setWorkerName(StringFilter workerName) {
        this.workerName = workerName;
    }

    public StringFilter getTrayNumber() {
        return trayNumber;
    }

    public void setTrayNumber(StringFilter trayNumber) {
        this.trayNumber = trayNumber;
    }

    public LongFilter getTbActivityId() {
        return tbActivityId;
    }

    public void setTbActivityId(LongFilter tbActivityId) {
        this.tbActivityId = tbActivityId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBNurseryDetailsCriteria that = (TBNurseryDetailsCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(workerName, that.workerName) &&
            Objects.equals(trayNumber, that.trayNumber) &&
            Objects.equals(tbActivityId, that.tbActivityId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        workerName,
        trayNumber,
        tbActivityId
        );
    }

    @Override
    public String toString() {
        return "TBNurseryDetailsCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (workerName != null ? "workerName=" + workerName + ", " : "") +
                (trayNumber != null ? "trayNumber=" + trayNumber + ", " : "") +
                (tbActivityId != null ? "tbActivityId=" + tbActivityId + ", " : "") +
            "}";
    }

}
